/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.jcg;

import jakarta.annotation.PostConstruct;
import java.util.List;
import org.springframework.ai.document.Document;
import org.springframework.stereotype.Component;
import org.springframework.ai.vectorstore.VectorStore;

/**
 *
 * @author omozegieaziegbe
 */
@Component
public class MovieStoragePipeline {

    private final VectorStore vectorStore;

    public MovieStoragePipeline(VectorStore vectorStore) {
        this.vectorStore = vectorStore;
    }

    @PostConstruct
    void run() {
        var movies = List.of(
                new Movie("Inception", "Christopher Nolan",
                        "A thief who enters the dreams of others to steal their secrets is given a chance to erase his criminal record."),
                new Movie("Interstellar", "Christopher Nolan",
                        "A group of astronauts travels through a wormhole in search of a new home for humanity."),
                new Movie("The Matrix", "The Wachowskis",
                        "A hacker learns that his world is a simulated reality and joins a rebellion against its controllers."),
                new Movie("The Social Network", "David Fincher",
                        "The story of Mark Zuckerberg and the creation of Facebook, a revolutionary social media platform."),
                new Movie("Parasite", "Bong Joon-ho",
                        "A poor family infiltrates a wealthy household, leading to unexpected consequences."),
                new Movie("Blade Runner", "Ridley Scott",
                        "Set in a dystopian future, a blade runner is tasked with hunting down bioengineered beings known as replicants."),
                new Movie("High-Rise", "Ben Wheatley",
                        "Residents of a luxury tower block descend into chaos as class divisions and societal breakdowns emerge."),
                new Movie("Children of Men", "Alfonso Cuarón",
                        "In a world where humans have become infertile, a disillusioned bureaucrat becomes the unlikely champion in the fight for humanity's survival."),
                new Movie("The Hunger Games", "Gary Ross",
                        "In a dystopian future, a young girl volunteers to participate in a televised battle to the death."),
                new Movie("Snowpiercer", "Bong Joon-ho",
                        "Survivors of a failed climate-change experiment live on a train circling the globe, where class warfare erupts.")
        );

        List<Document> documents = movies.stream()
                .map(movie -> new Document(movie.toString()))
                .toList();

        vectorStore.add(documents);
    }
}
